#ifndef EFL_ANIMATOR_EO_HH
#define EFL_ANIMATOR_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_ANIMATOR_FWD_GUARD
#define EFL_ANIMATOR_FWD_GUARD
namespace efl { 
struct Animator;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Animator> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Animator&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Animator const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Animator const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { 
struct Animator {
   static Efl_Class const* _eo_class()
   {
      return EFL_ANIMATOR_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Animator *>(this))); }
   operator ::efl::Animator() const;
   operator ::efl::Animator&();
   operator ::efl::Animator const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Animator> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Animator const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Animator : private ::efl::eo::concrete
{
   explicit Animator( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Animator(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Animator() = default;
   Animator(Animator const&) = default;
   Animator(Animator&&) = default;
   Animator& operator=(Animator const&) = default;
   Animator& operator=(Animator&&) = default;
   template <typename Derived>
   Animator(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Animator, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   static Efl_Class const* _eo_class()
   {
      return EFL_ANIMATOR_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Animator *>(this))); }
   static struct animator_tick_event
   {
      static Efl_Event_Description const* description()
      { return EFL_EVENT_ANIMATOR_TICK; }
      typedef Efl_Event_Animator_Tick parameter_type;
   } const animator_tick_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   animator_tick_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(animator_tick_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   animator_tick_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(animator_tick_event, *this, std::bind(function));
   }
#endif
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Animator> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Animator const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Animator> _get_wref() const { return ::efl::eo::wref<Animator>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Animator* operator->() const { return this; }
   Animator* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Animator const& lhs, Animator const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Animator const& lhs, Animator const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Animator) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Animator>::value, "");
} 
#endif
